--[[

	Wardrobe-AL

	By AnduinLothar karlkfi@yahoo.com

	Wardrobe lets you define up to 20 distinct equipment profiles 
	(called "outfits") and lets you switch among them on the fly.  
	For example, you can define a Normal Outfit that consists of 
	your regular equipment, an Around Town Outfit that consists of 
	what you'd like to wear when inside a city or roleplaying, a 
	Stamina Outfit that consists of all your best +stam gear, etc.  
	You can then switch amongst these outfits using a simple slash chat 
	command (/wardrobe wear Around Town Outfit), or using a small 
	interactive button docked beneath your radar.

   ]]--

WARDROBE_CONSTANTS_VERSION						= "1.6-AL";
WARDROBE_CONSTANTS_DEBUG						= false;
WARDROBE_CONSTANTS_NUM_OUTFITS					= 20;
WARDROBE_CONSTANTS_NUM_POPUP_FUNCTION_BUTTONS	= 1;
WARDROBE_CONSTANTS_UNMOUNT_OUTFIT_NAME			= "#unmount#";
WARDROBE_CONSTANTS_UNPLAGUE_OUTFIT_NAME			= "#unplague#";
WARDROBE_CONSTANTS_DONEEATING_OUTFIT_NAME		= "#doneeating#";
WARDROBE_CONSTANTS_TEMP_OUTFIT_NAME				= "#temp#";
Wardrobe.SpecialOutfitVirtualNames = {
	-- [specialID] -> virtualOutfitName
	["mounted"] = WARDROBE_CONSTANTS_UNMOUNT_OUTFIT_NAME,
	["chowing"] = WARDROBE_CONSTANTS_DONEEATING_OUTFIT_NAME,
	["plague"] = WARDROBE_CONSTANTS_UNPLAGUE_OUTFIT_NAME,
	["swimming"] = WARDROBE_CONSTANTS_DONESWIMMING_OUTFIT_NAME
};
Wardrobe.WaitingListVirtualNames = {
	-- [specialID] -> virtualOutfitName
	["mount"] = {id="mounted",toggle=true},
	["unmount"] = {id="mounted",toggle= false},
	["eating"] = {id="chowing",toggle=true},
	["uneating"] = {id="chowing",toggle=false},
	["plague"] = {id="plague",toggle=true},
	["unplague"] = {id="plague",toggle=false},
	["swim"] = {id="swimming",toggle=true},
	["unswim"] = {id="swimming",toggle= false}
};
WARDROBE_CONSTANTS_MAX_SCROLL_ENTRIES		= 9;

WARDROBE_CONSTANTS_NOISY					= false;
WARDROBE_CONSTANTS_NOWEAPONSUPPORT			= true;

WARDROBE_TITAN_ID 							= "Wardrobe";

WARDROBE_CONSTANTS_PLAGUEZONES	= {
	WARDROBE_CONSTANTS_TXT_WPLAGUELANDS,
	WARDROBE_CONSTANTS_TXT_EPLAGUELANDS, 
	WARDROBE_CONSTANTS_TXT_STRATHOLME,
	WARDROBE_CONSTANTS_TXT_SCHOLOMANCE
};


WARDROBE_CONSTANTS_TEXTCOLORS = {
	{1.00, 0.00, 0.00},	-- red
	{1.00, 0.50, 0.50},	-- light red
	{1.00, 0.50, 0.00},	-- orange
	{1.00, 0.75, 0.50},	-- light orange
	{1.00, 0.75, 0.00},	-- gold
	{1.00, 0.87, 0.50},	-- light gold

	{1.00, 1.00, 0.00},	-- yellow
	{1.00, 1.00, 0.50},	-- light yellow
	{0.50, 1.00, 0.00},	-- yellow-green
	{0.75, 1.00, 0.50},	-- light yellow-green
	{0.00, 1.00, 0.00},	-- green
	{0.50, 1.00, 0.50},	-- light green

	{0.00, 1.00, 0.50},	-- blue-green
	{0.50, 1.00, 0.75},	-- light blue-green
	{0.00, 1.00, 1.00},	-- cyan
	{0.50, 1.00, 1.00},	-- light cyan
	{0.00, 0.00, 1.00},	-- blue
	{0.50, 0.50, 1.00},	-- light blue

	{0.50, 0.00, 1.00},	-- blue-purple
	{0.75, 0.50, 1.00},	-- light blue-purple
	{1.00, 0.00, 1.00},	-- purple
	{1.00, 0.50, 1.00},	-- light purple
	{1.00, 0.00, 0.50},	-- pink-red
	{1.00, 0.50, 0.75}	 -- light pink-red
};
					  
WARDROBE_CONSTANTS_DRABCOLORS = {
	{0.50, 0.00, 0.00},	-- red
	{0.50, 0.25, 0.25},	-- light red
	{0.50, 0.25, 0.00},	-- orange
	{0.50, 0.38, 0.25},	-- light orange
	{0.50, 0.38, 0.00},	-- gold
	{0.50, 0.43, 0.25},	-- light gold
	
	{0.50, 0.50, 0.00},	-- yellow
	{0.50, 0.50, 0.25},	-- light yellow
	{0.25, 0.50, 0.00},	-- yellow-green
	{0.38, 0.50, 0.25},	-- light yellow-green
	{0.00, 0.50, 0.00},	-- green
	{0.25, 0.50, 0.25},	-- light green
	
	{0.00, 0.50, 0.25},	-- blue-green
	{0.25, 0.50, 0.38},	-- light blue-green
	{0.00, 0.50, 0.50},	-- cyan
	{0.25, 0.50, 0.50},	-- light cyan
	{0.00, 0.00, 0.50},	-- blue
	{0.25, 0.25, 0.50},	-- light blue
	
	{0.25, 0.00, 0.50},	-- blue-purple
	{0.38, 0.25, 0.50},	-- light blue-purple
	{0.50, 0.00, 0.50},	-- purple
	{0.50, 0.25, 0.50},	-- light purple
	{0.50, 0.00, 0.25},	-- pink-red
	{0.50, 0.25, 0.38},	-- light pink-red
};
					  
WARDROBE_CONSTANTS_DEFAULT_BUTTON_COLOR = 11;  -- corresponds to the entry in WARDROBE_CONSTANTS_TEXTCOLORS (in this case, #11 is green)
				  
Wardrobe.InventorySlots = {
	"HeadSlot",
	"NeckSlot",
	"ShoulderSlot",
	"BackSlot",
	"ChestSlot",
	"ShirtSlot",
	"TabardSlot",
	"WristSlot",
	"HandsSlot",
	"WaistSlot",
	"LegsSlot",
	"FeetSlot",
	"Finger0Slot",
	"Finger1Slot",
	"Trinket0Slot",
	"Trinket1Slot",
	"MainHandSlot",
	"SecondaryHandSlot",
	"RangedSlot"
};

Wardrobe.InventorySlotsSize = table.getn( Wardrobe.InventorySlots )

-- the variable that stores all the wardrobe info
-- and gets saved when you quit the game
Wardrobe_Config							= {};
Wardrobe_Config.Enabled					= true;
Wardrobe_Config.xOffset					= 10;
Wardrobe_Config.yOffset					= 39;
Wardrobe_Config.DefaultCheckboxState	= 1;	   -- default state for the checkboxes when specifying what equipment slots make up an outfit on the character paperdoll screen
Wardrobe_Config.MustClickUIButton		= false;   -- default state for the checkboxes when specifying what equipment slots make up an outfit on the character paperdoll screen
Wardrobe_Config.version					= WARDROBE_CONSTANTS_VERSION;

Wardrobe.Current_Outfit				= 0;
Wardrobe.InventorySearchForward		= 1;
Wardrobe.AlreadySetCharactersWardrobeID = false;	-- set this to true once we've looked up this character's wardrobe info
Wardrobe.PopupFunction				= "";	   -- tells the popup confirmation box what it's confirming (deleting an outfit, adding one, etc)
WARDROBE_CONSTANTS_POPUP_TITLE		= "";	   -- the title of the popup confirmation box
Wardrobe.Rename_OldName				= "";	   -- remembers original outfit name in case we cancel a rename
Wardrobe.BeingDragged				= false;	-- flag for dragging the wardrobe UI button
Wardrobe.DragLock					= false;	-- true if we're not allowed to drag the wardrobe UI button
Wardrobe.InCombat					= false;	-- true if we're in combat
Wardrobe.RegenEnabled				= true;	 -- true if we can't regen (usually means we're in combat)
Wardrobe.ShowingCharacterPanel		= false;	-- true if the character paperdoll frame is visible
Wardrobe.PressedAcceptButton		= false;	-- remembers if we pressed the accept button in case the character paperdoll frame closes via other means
Wardrobe.MountState					= false;	-- tracks whether we're mounted or not
Wardrobe.ChowingState				= false;	-- tracks whether we're in the process of eating / drinking
Wardrobe.WaitingList				= { };

--============================================================================================--
--============================================================================================--
--																							--
--							  INITIALIZATION FUNCTIONS									  --
--																							--
--============================================================================================--
--============================================================================================--


---------------------------------------------------------------------------------
-- Stuff done when the plugin first loads
---------------------------------------------------------------------------------
function Wardrobe.OnLoad()  

	-- watch our bags and update our wardrobe availability
	this:RegisterEvent("BAG_UPDATE");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_AURAS_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	--this:RegisterEvent("MIRROR_TIMER_START");  --Swimming Currently Disabled
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	
	Wardrobe.RegisterXMLRefrences();

	Wardrobe.RegisterOptionConfigs() 
end

---------------------------------------------------------------------------------
-- Convert all XML frames with the prefix "Wardrobe_Blah" to be refrenced by the Wardrobe.Blah equiv
-- An experiment in global namespace minimization
---------------------------------------------------------------------------------

function Wardrobe.RegisterXMLRefrences()
	local globalNameSpace = getfenv(0);
	local tempTable = {};
	local newName, newValue, foundString, number;
	local globalName, globalValue = next(globalNameSpace);
	while (globalName ~= nil) do
		newName, newValue = next(globalNameSpace, globalName);
		if ( type(globalName) == "string" ) and ( type(globalValue) == "table" ) and ( strfind(globalName, "Wardrobe_") ) then
			foundString, number = string.gsub(globalName, "^Wardrobe_", "")
			if (number > 0) and (globalValue.GetName) then
				tempTable[foundString] = globalValue;
				if (foundString ~= "MainMenuFrameTitle") and (foundString ~= "IconFrame") and (foundString ~= "PopupTitle") and (not strfind(foundString, "SortScrollFrame")) and (not strfind(foundString, "MainMenuFrameEntry")) then
					--Leave ScrollFrame refrences for template Compatibility
					--Leave Minimap Button refrences for MobileMinimapFrame Use
					--Leave PopupTitle refrences for ColorCycle Use
					--Leave MainMenuFrameTitle refrences for ColorCycle Use
					--Leave MainMenuFrameEntrys refrences for ColorCycle Use
					globalNameSpace[globalName] = nil;
				end
			end
		end
		globalName,globalValue = newName,newValue;
	end
	for n, v in tempTable do
		globalNameSpace.Wardrobe[n] = v;
	end
end


---------------------------------------------------------------------------------
-- Register Option Configs
---------------------------------------------------------------------------------
function Wardrobe.RegisterOptionConfigs()
	
	if (Khaos) then
		Wardrobe.RegisterKhaos();
	elseif (Cosmos_RegisterConfiguration) then 
		Wardrobe.RegisterCosmos();
	end
	
	local WardrobeCommands = {"/wardrobe","/wd"};
	if (Sky) then
		Sky.registerSlashCommand(
			{
				id="Wardrobe";
				commands = WardrobeCommands;
				onExecute = Wardrobe.ChatCommandHandler;
				helpText = WARDROBE_CONSTANTS_CHAT_COMMAND_INFO;
			}
		);
	elseif (Cosmos_RegisterChatCommand) then
		Cosmos_RegisterChatCommand (
			"WARDROBE_CONSTANTS_COMMANDS", -- Some Unique Group ID
			WardrobeCommands, -- The Commands
			Wardrobe.ChatCommandHandler,
			WARDROBE_CONSTANTS_CHAT_COMMAND_INFO -- Description String
		);
	else
		SlashCmdList["WARDROBESLASH"] = Wardrobe.ChatCommandHandler;
		for i, slash in WardrobeCommands do
			setglobal("SLASH_WARDROBESLASH"..i, slash);
		end
	end
	
	-- makes sure we have a Print() command, just in
	-- case cosmos isn't installed
	if(not Print) then
		function Print(msg, r, g, b, frame) 
			if (not r) then r = 1.0; end
			if (not g) then g = 1.0; end
			if (not b) then b = 1.0; end
			if ( frame ) then 
				frame:AddMessage(msg,r,g,b);
			else
				if ( DEFAULT_CHAT_FRAME ) then 
					DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
				end
			end
		end
	end
end

function Wardrobe.RegisterKhaos()
	local optionSet = {
		id="Wardrobe";
		text=WARDROBE_CONSTANTS_CONFIG_HEADER;
		helptext=WARDROBE_CONSTANTS_CONFIG_HEADER_INFO;
		callback=function(state) Wardrobe.Toggle(state and 1); end;
		feedback=function(state) return state and WARDROBE_CONSTANTS_TXT_ENABLED or WARDROBE_CONSTANTS_TXT_DISABLED end;
		difficulty=1;
		default={checked=true};
		options={
			{
				id="Header";
				text=WARDROBE_CONSTANTS_CONFIG_HEADER;
				helptext=WARDROBE_CONSTANTS_CONFIG_HEADER_INFO;
				type=K_HEADER;
			};
		};
	};
	Khaos.registerOptionSet(
		"other",
		optionSet
	);
end

function Wardrobe.RegisterCosmos()
	Cosmos_RegisterConfiguration(
		"COS_WARDROBE",
		"SECTION",
		WARDROBE_CONSTANTS_CONFIG_HEADER,
		WARDROBE_CONSTANTS_CONFIG_HEADER_INFO
	);
	Cosmos_RegisterConfiguration(
		"COS_WARDROBE_CONSTANTS_HEADER",
		"SEPARATOR",
		WARDROBE_CONSTANTS_CONFIG_HEADER,
		WARDROBE_CONSTANTS_CONFIG_HEADER_INFO
	);
	Cosmos_RegisterConfiguration(
		"COS_WARDROBE_CONSTANTS_ENABLED",
		"CHECKBOX",
		WARDROBE_CONSTANTS_CONFIG_ENABLED,
		WARDROBE_CONSTANTS_CONFIG_ENABLED_INFO,
		Wardrobe.Toggle,
		Wardrobe_Config.Enabled
	);
end

---------------------------------------------------------------------------------
-- Event handler
---------------------------------------------------------------------------------
function Wardrobe.OnEvent(event)

	if (Wardrobe_Config.Enabled) then	   
		if (event == "PLAYER_REGEN_DISABLED") then
			--Sea.io.print("PLAYER_REGEN_DISABLED");
			Wardrobe.RegenEnabled = false;
		elseif (event == "PLAYER_REGEN_ENABLED") then
			--Sea.io.print("PLAYER_REGEN_ENABLED");
			Wardrobe.RegenEnabled = true;
			if (not Wardrobe.IsPlayerInCombat()) then
				Wardrobe.CheckForMounted();
				Wardrobe.CheckForEatDrink();
				Wardrobe.CheckWaitingList();
			end
		elseif (event == "PLAYER_ENTER_COMBAT") then
			--Sea.io.print("PLAYER_ENTER_COMBAT");
			Wardrobe.InCombat = true;
		elseif (event == "PLAYER_LEAVE_COMBAT") then
			--Sea.io.print("PLAYER_LEAVE_COMBAT");
			Wardrobe.InCombat = false;
			if (not Wardrobe.IsPlayerInCombat()) then
				Wardrobe.CheckWaitingList();
			end
		elseif (event == "PLAYER_AURAS_CHANGED") then
			--if (not Wardrobe.IsPlayerInCombat()) then
				if (Chronos) then
					Chronos.scheduleByName("WardrobeAuraCheck", .2, Wardrobe.AuraCheck);
				else
					Wardrobe.CheckForMounted();
					Wardrobe.CheckForEatDrink();
				end
			--end
		elseif (event == "ZONE_CHANGED_NEW_AREA") then
			Wardrobe.ChangedZone();
		elseif (event == "MIRROR_TIMER_START") then
			Wardrobe.CheckForSwimming();
		elseif (event == "PLAYER_ENTERING_WORLD") then
			Wardrobe.UpdateOldConfigVersions();
			Wardrobe.CheckForMounted();
			Wardrobe.CurrentZone = GetZoneText();
			Wardrobe.ChangedZone();
		end
	end
end

function Wardrobe.AuraCheck()
	Wardrobe.CheckForMounted();
	Wardrobe.CheckForEatDrink();
end



---------------------------------------------------------------------------------
-- Return true if we're in combat
---------------------------------------------------------------------------------
function Wardrobe.IsPlayerInCombat() 
	if (Wardrobe.InCombat or (not Wardrobe.RegenEnabled)) then
		return true;
	else
		return false;
	end
end


---------------------------------------------------------------------------------
-- Update outdated config information
---------------------------------------------------------------------------------
function Wardrobe.UpdateOldConfigVersions()
	if (Wardrobe_Config.DefaultCheckboxState == nil) then
		Wardrobe.Debug("Adding DefaultCheckboxState to Wardrobe_Config.");
		Wardrobe_Config.DefaultCheckboxState = 1;
	else
		Wardrobe.Debug("Wardrobe_Config.DefaultCheckboxState = "..tostring(Wardrobe_Config.DefaultCheckboxState));		
	end
end


--============================================================================================--
--============================================================================================--
--																							--
--							  CHAT COMMAND FUNCTIONS										--
--																							--
--============================================================================================--
--============================================================================================--


---------------------------------------------------------------------------------
-- Break a chat command into its command and variable parts (i.e. "debug on" 
-- will break into command = "debug" and variable = "on", or "add my spiffy wardrobe"
-- breaks into command = "add" and variable = "my spiffy wardrobe"
---------------------------------------------------------------------------------
function Wardrobe.ParseCommand(msg)
	firstSpace = string.find(msg, " ", 1, true);
	if (firstSpace) then
		local command = string.sub(msg, 1, firstSpace - 1);
		local var  = string.sub(msg, firstSpace + 1);
		return command, var
	else
		return msg, nil;
	end
end


---------------------------------------------------------------------------------
-- A simple chat command handler.  takes commands in the form "/wardrobe command var"
---------------------------------------------------------------------------------
function Wardrobe.ChatCommandHandler(msg)
	local command, var = Wardrobe.ParseCommand(msg);
	if ((not command) and msg) then
		command = msg;
	end
	if (command) then
		command = string.lower(command);
		if (command == WARDROBE_CONSTANTS_CMD_RESET) then
			Wardrobe.EraseAllOutfits();
		elseif (command == WARDROBE_CONSTANTS_CMD_LIST) then
			Wardrobe.ListOutfits(var);
		elseif (command == WARDROBE_CONSTANTS_CMD_WEAR or command == WARDROBE_CONSTANTS_CMD_WEAR2 or command == WARDROBE_CONSTANTS_CMD_WEAR3) then
			Wardrobe.WearOutfit(var);
		elseif (command == WARDROBE_CONSTANTS_CMD_ON) then
			Wardrobe.Toggle(1);
		elseif (command == WARDROBE_CONSTANTS_CMD_OFF) then
			Wardrobe.Toggle(0);
		elseif (command == WARDROBE_CONSTANTS_CMD_LOCK) then
			Wardrobe.ToggleLockButton(true);
		elseif (command == WARDROBE_CONSTANTS_CMD_UNLOCK) then
			Wardrobe.ToggleLockButton(false);
		elseif (command == WARDROBE_CONSTANTS_CMD_CLICK) then
			Wardrobe.ToggleClickButton(true);
		elseif (command == WARDROBE_CONSTANTS_CMD_MOUSEOVER) then
			Wardrobe.ToggleClickButton(false);
		elseif (command == WARDROBE_CONSTANTS_CMD_VERSION) then
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_WARDROBEVERSION.." "..WARDROBE_CONSTANTS_VERSION);
		elseif (command == "testcheck") then
			Wardrobe.ShowWardrobe_ConfigurationScreen();
		elseif (command == "testsort") then
			Wardrobe.ShowMainMenu();
		elseif (command == "debug") then
			Wardrobe.ToggleDebug();
		elseif (command == "report") then
			Wardrobe.DumpDebugReport();
		elseif (command == "itemlist") then
			Wardrobe.BuildItemList();
		elseif (command == "struct") then
			Wardrobe.DumpDebugStruct();
		else
			Wardrobe.ShowHelp();
		end
	end
end



--============================================================================================--
--============================================================================================--
--																							--
--							  WARDROBE MAIN FUNCTIONS									   --
--																							--
--============================================================================================--
--============================================================================================--

---------------------------------------------------------------------------------
-- Each character on an account has an ID assigned to it that specifies its wardrobes
-- This function returns the ID associated with this character
---------------------------------------------------------------------------------
function Wardrobe.GetThisCharactersWardrobeID()

   Wardrobe.Debug("Looking up this character's wardrobe number...");

   -- upgrade old versions
   if ( Wardrobe_Config.version == nil ) then
	Wardrobe_Config = nil;
	Wardrobe_Config = { };
	Wardrobe_Config.Enabled				 = true;
	Wardrobe_Config.xOffset				 = 10;
	Wardrobe_Config.yOffset				 = 39;
	Wardrobe_Config.DefaultCheckboxState	= 1;	   -- default state for the checkboxes when specifying what equipment slots make up an outfit on the character paperdoll screen
	Wardrobe_Config.MustClickUIButton	   = false;   -- default state for the checkboxes when specifying what equipment slots make up an outfit on the character paperdoll screen
	Wardrobe_Config.version = WARDROBE_CONSTANTS_VERSION;
	Wardrobe.Print("Erasing old Wardrobe_Config because it don't support realm");
   elseif ( not Wardrobe_Config.version == WARDOBE_VERSION ) then
	Wardrobe_Config.version = WARDROBE_CONSTANTS_VERSION;
   end
   
   -- Look for this realm in the wardrobe table
   WD_RealmName = GetRealmName();
   WD_realmID = nil;

   for i = 1, table.getn(Wardrobe_Config) do
	  if ( Wardrobe_Config[i].RealmName == WD_RealmName ) then
		 WD_realmID = i;
		 break;
	  end;
   end;

	-- if we didn't find this realm, add us to the wardrobe table
	if (not WD_realmID) then
		Wardrobe.AddThisRealmToWardrobeTable();
		WD_realmID = table.getn(Wardrobe_Config);
	end
	

   -- look for this character in the wardrobe table
   WD_charID = nil;
   WD_PlayerName = UnitName("player")

   for i = 1, table.getn(Wardrobe_Config[WD_realmID]) do
	  if (Wardrobe_Config[WD_realmID][i].PlayerName == WD_PlayerName) then
		 WD_charID = i;
		 break;
	   end
   end
	
	-- if we didn't find this character, add us to the wardrobe table
	if (not WD_charID) then
		Wardrobe.AddThisCharacterToWardrobeTable();
		WD_charID = table.getn(Wardrobe_Config[WD_realmID]);
	end
	
	Wardrobe.ButtonUpdateVisibility();
	
	Wardrobe.Debug("This character's wardrobe number is: "..WD_charID);

	-- flag that we've already found / created this character's wardrobe entry
	Wardrobe.AlreadySetCharactersWardrobeID = true;
end


---------------------------------------------------------------------------------
-- Checks to see if we've already looked up the number associated with this character
-- If not, grab the number
---------------------------------------------------------------------------------
function Wardrobe.CheckForOurWardrobeID()
	if (not Wardrobe.AlreadySetCharactersWardrobeID) then
		Wardrobe.GetThisCharactersWardrobeID();
	end
end


-- NOTES ABOUT DATASTRUCTURES:
--
-- For each character, the wardrobes are stored in a datastructure that looks like this
-- 
-- x = total number of outfits
-- y = total slots on a character (head, feet, hands, etc)
--
-- Outfit[x]		  -- the datastructure for a single outfit
--
--	 SortNumber	   -- specifies the position this outfit will appear in the list of outfits when the list is sorted
--	 OutfitName	   -- the name of this outfit
--	 Available		-- true if all of the items in this outfit are in our bags or equiped
--	 Mounted		  -- true if this is the outfit to be worn when we mount
--	 Virtual		  -- true if this outfit is virtual (not a real outfit, but only used as temporary storage)
--	 Selected		 -- true if this outfit is the currently selected outfit on the menu screen (highlighted white)
--	 Item[1]		  -- the data structure for all the items in this outfit
--		  Name		-- the name of the item
--		  IsSlotUsed  -- 1 if this outfit uses this slot, 0 if not (i.e. an outfit might not involve your trinkets, or might only consist of your rings)
--		.
--		.
--		.
--	 Item[y]	  
--
-- So, let's say you have two outfits in your wardrobe.  Wardrobe[1] represents outfit 1, and Wardrobe[2] 
-- represents outfit 2.  for outfit 1, Wardrobe[1].OutfitName would be the name of this outfit (say, "In town outfit").  
-- the item on your character slot 5 would be Wardrobe[1].Item[5].Name.  Since all these are stored per character, the
-- actual datastructure would look like:
--
-- Wardrobe_Config[WD_realmID][3].Wardrobe[1].Item[5].Name --> for character 3, outfit 1, item 5


---------------------------------------------------------------------------------
-- Add an entry for this realm to the main table of wardrobes
---------------------------------------------------------------------------------
function Wardrobe.AddThisRealmToWardrobeTable()
	
	Wardrobe.Debug("Didn't find a wardrobe ID for this realm.  Adding this realm to the table...");
	
	-- build the structure for this realm's wardrobe
	tempTable = { };
	tempTable.RealmName = WD_RealmName;
	
	-- stick this structure into the main table of wardrobes
	table.insert(Wardrobe_Config, tempTable);
end


---------------------------------------------------------------------------------
-- Add an entry for this character to the main table of wardrobes
---------------------------------------------------------------------------------
function Wardrobe.AddThisCharacterToWardrobeTable()
	
	Wardrobe.Debug("Didn't find a wardrobe ID for this character.  Adding this character to the table...");
	
	-- build the structure for this char's wardrobe
	tempTable = { };
	tempTable.PlayerName = WD_PlayerName
	tempTable.Outfit = { };
	
	-- stick this structure into the main table of wardrobes
	table.insert(Wardrobe_Config[WD_realmID], tempTable);
end


---------------------------------------------------------------------------------
-- Create and return a blank outfit structure
---------------------------------------------------------------------------------
function Wardrobe.CreateBlankOutfit()
	local tempTable2 = { };
	tempTable2.SortNumber = nil;
	tempTable2.OutfitName = "";
	tempTable2.Available = false;
	tempTable2.Special = "";
	tempTable2.Virtual = false;
	tempTable2.Selected = false;
	tempTable2.ButtonColor = WARDROBE_CONSTANTS_DEFAULT_BUTTON_COLOR;
	tempTable2.Item = { };
	for i = 1, Wardrobe.InventorySlotsSize do
		tempTable3 = { };
		tempTable3.Name = "";
		tempTable3.IsSlotUsed = Wardrobe_Config.DefaultCheckboxState;
		table.insert(tempTable2.Item, tempTable3);
	end
	
	return tempTable2;
end


---------------------------------------------------------------------------------
-- Add the named outfit to our wardrobe
---------------------------------------------------------------------------------
function Wardrobe.AddNewOutfit(outfitName, buttonColor)   

	 if (Wardrobe_Config.Enabled) then
	
		-- if we haven't already looked up our character's number
		Wardrobe.CheckForOurWardrobeID();

		if (not outfitName) then
			return;
		end
		
		-- make sure we don't already have an outfit with the same name
		if (Wardrobe.FoundOutfitName(outfitName)) then
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_OUTFITNAMEEXISTS);   
			return;
		end

		Wardrobe.Debug("Trying to set this wardrobe as \""..outfitName.."\"");

		-- if we found a free outfit slot
		local outfitNum = Wardrobe.GetNextFreeOutfitSlot();
		if (outfitNum ~= 0) then
		
			-- store our current equipment in this outfit
			Wardrobe.StoreItemsInOutfit(outfitName, outfitNum, "added");
			Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].ButtonColor = buttonColor;
		-- otherwise we've used the maximum number of outfits
		else
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_USEDUPALL.." "..WARDROBE_CONSTANTS_NUM_OUTFITS.." "..WARDROBE_CONSTANTS_TXT_OFYOUROUTFITS, 1.0, 0.0, 0.0);
		end
	end
end


---------------------------------------------------------------------------------
-- Create and return the index of the next free outfit slot
---------------------------------------------------------------------------------
function Wardrobe.GetNextFreeOutfitSlot(addingVirtualOutfit)

	-- find next unused outfit slot
	local outfitNum = 0;
	
	local outfitCount = 0;
	for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
		if (not Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Virtual) then outfitCount = outfitCount + 1; end
	end
	
	-- if we aren't already using our max number of outfits
	if (outfitCount < WARDROBE_CONSTANTS_NUM_OUTFITS or addingVirtualOutfit) then
	
		-- add another outfit to the list and return its index
		table.insert(Wardrobe_Config[WD_realmID][WD_charID].Outfit, Wardrobe.CreateBlankOutfit());
		outfitNum = table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit);
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber = outfitNum;
	end
		
	return outfitNum;	
end


---------------------------------------------------------------------------------
-- Store our currently equipped items in the specified outfit name
---------------------------------------------------------------------------------
function Wardrobe.StoreItemsInOutfit(outfitName, outfitNum, printMessage)

	-- store the name of this outfit
	Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].OutfitName = outfitName;
	if (not Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Special) then
		 Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Special = "";
	end
	Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Virtual = false;

	-- for each slot on our character's person (hands, feet, etc)
	for i = 1, Wardrobe.InventorySlotsSize do	   
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].IsSlotUsed = Wardrobe.ItemCheckState[i];
		if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].IsSlotUsed == 1) then
			local itemID, permEnchant, tempEnchant, suffix, itemName = Wardrobe.GetItemInfoAtInventorySlotNumber(i);
			Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].Name = itemName;
			Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].ItemID = itemID;
			Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].Suffix = suffix;
			Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].PermEnchant = permEnchant;
		end
		if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].IsSlotUsed == 1) then
			Wardrobe.Debug("	Setting USED slot "..Wardrobe.InventorySlots[i].." = ["..tostring(Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].Name).."]");
		else
			Wardrobe.Debug("	Setting unused slot "..Wardrobe.InventorySlots[i].." = [".. tostring(Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Item[i].Name).."]");
		end
	end 

	-- all the items in this outfit are currently available in the player's inventory
	Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].Available = true;

	if (printMessage) then
		Wardrobe.Print(WARDROBE_CONSTANTS_TXT_OUTFIT.." \""..outfitName.."\" "..printMessage..".");
	end
end


---------------------------------------------------------------------------------
-- Update an outfit
---------------------------------------------------------------------------------
function Wardrobe.UpdateOutfit(outfitName, buttonColor)

	if (Wardrobe_Config.Enabled) then
	
		-- if we haven't already looked up our character's number
		Wardrobe.CheckForOurWardrobeID();
			 
		-- check to see if the wardrobe doesn't exist
		if (outfitName == nil or outfitName == "") then
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_PLEASEENTERNAME);
		elseif (not Wardrobe.FoundOutfitName(outfitName)) then
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_OUTFITNOTEXIST);
			UIErrorsFrame:AddMessage(WARDROBE_CONSTANTS_TXT_NOTEXISTERROR, 1.0, 0.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
		else

			-- find the outfit to update
			for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do

				-- if we found the outfit, store our equipment
				if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName == outfitName) then
					Wardrobe.StoreItemsInOutfit(outfitName, i, WARDROBE_CONSTANTS_TXT_UPDATED);
					Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].ButtonColor = buttonColor;
				end
			end
		end
	end
end


---------------------------------------------------------------------------------
-- Erase the named outfit
---------------------------------------------------------------------------------
function Wardrobe.EraseOutfit(outfitName, silent)  

	if (Wardrobe_Config.Enabled) then
	
		-- if we haven't already looked up our character's number
		Wardrobe.CheckForOurWardrobeID();
		
		Wardrobe.Debug("Trying to delete outfit \""..outfitName.."\"");

		-- find the outfit to erase
		for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do

			-- if we found the outfit
			if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName == outfitName) then

				-- remove the outfit
				table.remove(Wardrobe_Config[WD_realmID][WD_charID].Outfit, i);
				Wardrobe.RenumberSortNumbers();
				
				--Wardrobe.RemoveAPopupButton(outfitName);

				if (not DoEraseAll and not silent) then
					Wardrobe.Print(WARDROBE_CONSTANTS_TXT_OUTFIT.." \""..outfitName.."\" "..WARDROBE_CONSTANTS_TXT_DELETED);
					Wardrobe.ListOutfits();
					UIErrorsFrame:AddMessage(WARDROBE_CONSTANTS_TXT_OUTFIT.." \""..outfitName.."\" "..WARDROBE_CONSTANTS_TXT_DELETED, 0.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
				end
				return true;
			end
		end

		Wardrobe.Print(WARDROBE_CONSTANTS_TXT_UNABLETOFIND.." \""..outfitName.."!\"");
		UIErrorsFrame:AddMessage(WARDROBE_CONSTANTS_TXT_UNABLEFINDERROR, 1.0, 0.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
		return false;
	end
end


---------------------------------------------------------------------------------
-- Erase all our outfits
---------------------------------------------------------------------------------
function Wardrobe.EraseAllOutfits()

	if (Wardrobe_Config.Enabled) then
	
		-- if we haven't already looked up our character's number
		Wardrobe.CheckForOurWardrobeID();

		-- delete all the outfits
		Wardrobe_Config[WD_realmID][WD_charID].Outfit = { };
		
		-- hide the main menu
		Wardrobe.ToggleMainMenuFrameVisibility(false);
		
		Wardrobe.Print(WARDROBE_CONSTANTS_TXT_ALLOUTFITSDELETED);
		UIErrorsFrame:AddMessage(WARDROBE_CONSTANTS_TXT_ALLOUTFITSDELETED, 0.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
	end
end


---------------------------------------------------------------------------------
-- Print a list of our outfits
---------------------------------------------------------------------------------
function Wardrobe.ListOutfits(var)

	if (Wardrobe_Config.Enabled) then
	
		-- if we haven't already looked up our character's number
		Wardrobe.CheckForOurWardrobeID();

		local foundOutfits = false;
		Wardrobe.Print(WARDROBE_CONSTANTS_TXT_YOURCURRENTARE);

		-- for each outfit
		for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do

			-- if it has a name and isn't virtual
			if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName ~= "" and (not Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Virtual)) then
				Wardrobe.Print("	o "..Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName);
				foundOutfits = true;

				-- if we asked for a detailed printout, show all the items
				if (var == "items") then
					for j = 1, Wardrobe.InventorySlotsSize do	
						if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Item[j].Name) and (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Item[j].Name ~= "") then
						   Wardrobe.Print("		["..Wardrobe.InventorySlots[j].." -> "..Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Item[j].Name.."]");
						end
					end		   
				end
			end
		end

		if (not foundOutfits) then
			Wardrobe.Print("  "..WARDROBE_CONSTANTS_TXT_NOOUTFITSFOUND);
		end
	end
end


---------------------------------------------------------------------------------
-- Wear an outfit
---------------------------------------------------------------------------------
function Wardrobe.WearOutfit(wardrobeName, silent)

	if (Wardrobe_Config.Enabled) then
	
		 -- if we haven't already looked up our character's number
		 Wardrobe.CheckForOurWardrobeID();

		-- if the user didn't specify a wardrobe to wear
		if (not wardrobeName) then

			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_SPECIFYOUTFITTOWEAR);
			return;

		-- else use the specified wardrobe
		else
			OutfitNumber = 0;
			for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
				Wardrobe.Debug("In WearOutfit, Looking at outfit #"..i.."  name = ["..Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName.."]");
				if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName == wardrobeName) then
					OutfitNumber = i;
					Wardrobe.Debug("Wardrobe.WearOutfit: Found outfit at #"..OutfitNumber);
					break;
				end
			end

			if (OutfitNumber == 0) then
				Wardrobe.Print(WARDROBE_CONSTANTS_TXT_UNABLEFIND.." \""..wardrobeName.."\" "..WARDROBE_CONSTANTS_TXT_INYOURLISTOFOUTFITS);
				return;	   
			end
		end

		Wardrobe.Debug(WARDROBE_CONSTANTS_TXT_SWITCHINGTOOUTFIT.." \""..wardrobeName.."\"");

		-- this variable "freeBagSpacesUsed" lets us track which empty pack spaces we've
		-- already assigned an item to be put into.  we need to do this because when we remove
		-- items from our character and put them into our bags, the server takes time to actually
		-- move the item into the bag.  during this delay, we may be still removing items, and we
		-- may see a slot that LOOKS empty but really the server just hasn't gotten around to moving
		-- a previous item into the slot.  this variable lets us mark each empty slot once we've assigned
		-- an item to it so that we don't try to use the same empty slot for another item.
		local freeBagSpacesUsed = { };

		-- tracks how our switching is going.  if at any point we can't remove an item (bags are full, etc),
		-- this will get set to false
		local switchResult = true;
		local itemID, permEnchant, tempEnchant, suffix, invItemName, outfitItem, outfitItemName, outfitItemID, outfitPermEnchant;
		-- for each slot on our character (hands, neck, head, feet, etc)
		for i = 1, Wardrobe.InventorySlotsSize do
			theSlotID = GetInventorySlotInfo(Wardrobe.InventorySlots[i]);
			outfitItem = Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Item[i];
			outfitItemName = outfitItem.Name;
			outfitItemID = outfitItem.ItemID;
			outfitSuffix = outfitItem.Suffix;
			outfitPermEnchant = outfitItem.PermEnchant;
			Wardrobe.Debug("Working on slot -> "..Wardrobe.InventorySlots[i]);

			-- if this slot is used in this outfit
			if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Item[i].IsSlotUsed == 1) then
			
				itemID, permEnchant, tempEnchant, suffix, invItemName = Wardrobe.GetItemInfoAtInventorySlotNumber(i);
				
				-- if we've set an item for this slot
				if (((outfitItemID) and (outfitSuffix) and (outfitPermEnchant)) and ((outfitItemID ~= itemID) or (outfitSuffix ~= suffix) or (outfitPermEnchant ~= permEnchant))) or ((outfitItemName) and (outfitItemName ~= "") and (outfitItemName ~=  invItemName)) then
					-- equip the correct item
					Wardrobe.Debug("	  Didn't match!  Switching out "..Wardrobe.InventorySlots[i].." for ["..outfitItemName.."]");
					if (not Wardrobe.Equip(outfitItemName, theSlotID, outfitItemID, outfitSuffix, outfitPermEnchant)) then
						Wardrobe.Print(WARDROBE_CONSTANTS_TXT_WARNINGUNABLETOFIND.." \""..outfitItemName.."\" "..WARDROBE_CONSTANTS_TXT_INYOURBAGS);
					elseif (not outfitItemID) or (not outfitSuffix) or (not outfitPermEnchant) then
						-- Item not stored with itemID info
						--Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Item[i].ItemID = itemID;
						--Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Item[i].Suffix = suffix;
						--Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Item[i].PermEnchant = permEnchant;
						--Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Item[i].TempEnchant = tempEnchant;
					end
				
				-- Forced Empty Slot, slot currently has an item in it
				elseif (invItemName) and ((not outfitItemName) or (outfitItemName == "")) then
					-- if inventory slot has an item equipped and it's a duel slot then check the next slots for swapping 
					local swapped = false;
					if (Wardrobe.InventorySlots[i] == "MainHandSlot") or (Wardrobe.InventorySlots[i] == "Finger0Slot") or (Wardrobe.InventorySlots[i] == "Trinket0Slot") then
						-- Next Inv Slot
						outfitItem = Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Item[i+1];
						outfitItemName = outfitItem.Name;
						outfitItemID = outfitItem.ItemID;
						outfitSuffix = outfitItem.Suffix;
						outfitPermEnchant = outfitItem.PermEnchant;
						if ((outfitItemID) and (outfitSuffix) and (outfitPermEnchant) and (outfitItemID == itemID) and (outfitSuffix == suffix) and (outfitPermEnchant == permEnchant)) or ((outfitItemName) and (outfitItemName ==  invItemName)) then
							-- Put secondary slot item in bag
							local secondarySlotID = GetInventorySlotInfo(Wardrobe.InventorySlots[i+1]);
							PickupInventoryItem(secondarySlotID);
							result, freeBagSpacesUsed = BagItem(freeBagSpacesUsed);
							switchResult = switchResult and result;
							Wardrobe.Debug("   Trying to remove "..Wardrobe.InventorySlots[i].." ( slot ID #"..theSlotID..")");
							
							-- Equip primary slot item to secondary slot
							PickupInventoryItem(theSlotID);
							EquipCursorItem(secondarySlotID);
							Wardrobe.Debug("	  Matched Next Slot!  Moving "..Wardrobe.InventorySlots[i].." item to "..Wardrobe.InventorySlots[i+1]..".");
							swapped = true;
						end
					end
					
					-- this outfit doesn't use an item for this inventory slot (i.e. no gloves in this wardrobe)
					if (not swapped) then
						-- grab the inventory item and bag it
						PickupInventoryItem(theSlotID);
						result, freeBagSpacesUsed = BagItem(freeBagSpacesUsed);
						Wardrobe.Debug("   Trying to remove "..Wardrobe.InventorySlots[i].." ( slot ID #"..theSlotID..")");
					end
					
					-- if we failed to switch, this will let us know
					switchResult = switchResult and result;
				
				-- Item found was item desired
				else
					Wardrobe.Debug("	  Matched!  No need to switch out "..Wardrobe.InventorySlots[i]..".");
				end
			end	
		end 

		-- only errorcheck when dealing with non-virtual outfits
		if (not Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Virtual and not silent) then
		
			-- if everything went OK
			if (switchResult) then
				if ( WARDROBE_CONSTANTS_NOISY ) then
					Wardrobe.Print(WARDROBE_CONSTANTS_TXT_SWITCHEDTOOUTFIT.." \""..wardrobeName..".\"");
				end
				Wardrobe.Current_Outfit = OutfitNumber;
			else
				Wardrobe.Print(WARDROBE_CONSTANTS_TXT_PROBLEMSCHANGING);
			end
		end	
	end
end


---------------------------------------------------------------------------------
-- Rename an outfit
---------------------------------------------------------------------------------
function Wardrobe.RenameOutfit(oldName, newName)

	if (Wardrobe_Config.Enabled) then	

		-- check to see if the new name is already being used
		if (not Wardrobe.FoundOutfitName(newName) and newName ~= "") then
			for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
				if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName == oldName) then
					Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName = newName;
					break;
				end
			end   
			UIErrorsFrame:AddMessage(WARDROBE_CONSTANTS_TXT_OUTFITRENAMEDERROR, 0.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_OUTFITRENAMEDTO.." \""..oldName.."\" "..WARDROBE_CONSTANTS_TXT_TOWORDONLY.." \""..newName.."\"");
		end
	end
end



---------------------------------------------------------------------------------
-- Comparison function for sorting outfits
---------------------------------------------------------------------------------
function Wardrobe.SortOutfitCompare(outfit1, outfit2)
	if (outfit1.SortNumber < outfit2.SortNumber) then
		return true;
	else
		return false;
	end
end


---------------------------------------------------------------------------------
-- Sort the outfits based on the .SortNumber property
---------------------------------------------------------------------------------
function Wardrobe.SortOutfits()
	table.sort(Wardrobe_Config[WD_realmID][WD_charID].Outfit, Wardrobe.SortOutfitCompare);
	
	Wardrobe.RenumberSortNumbers();
end


---------------------------------------------------------------------------------
-- Re-number the .SortNumbers so they start at 1 and go up by 1
---------------------------------------------------------------------------------
function Wardrobe.RenumberSortNumbers()
	for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].SortNumber = i;
	end
end


---------------------------------------------------------------------------------
-- Re-order an outfit in the list of outfits
---------------------------------------------------------------------------------
function Wardrobe.OrderOutfit(outfitNum, direction)
	if (outfitNum == 1 and direction < 0) then return; end
	if (outfitNum == table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) and direction > 0) then return; end
	
	if (direction > 0) then
		
		swapNum = 0;
		for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
			if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].SortNumber == Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber + 1) then
				swapNum = i;
				break;
			end
		end
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[swapNum].SortNumber = Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber = Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber + 1;
	else
		swapNum = 0;
		for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
			if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].SortNumber == Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber - 1) then
				swapNum = i;
				break;
			end
		end
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[swapNum].SortNumber = Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber = Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNum].SortNumber - 1;
	end
	
	return swapNum;	
end


---------------------------------------------------------------------------------
-- return the index of the selected outfit, or nil if none
---------------------------------------------------------------------------------
function Wardrobe.FindSelectedOutfit()
	local outfitNum = nil;
	for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
		if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Selected) then
			outfitNum = i;
			break;
		end
	end

	return outfitNum;	
end


---------------------------------------------------------------------------------
-- Tag this outfit to be worn when mounted
---------------------------------------------------------------------------------
function Wardrobe.SetMountedOutfit(outfitName)
	OutfitNumber = nil;
	for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Special = "";
		if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName == outfitName) then
			OutfitNumber = i;
		end
	end
	if (OutfitNumber == nil) then
		Wardrobe.Print(WARDROBE_CONSTANTS_TXT_UNABLETOFINDOUTFIT.." \""..outfitName..".\"");
	else
		Wardrobe_Config[WD_realmID][WD_charID].Outfit[OutfitNumber].Special = "mounted";
		Wardrobe.Print(WARDROBE_CONSTANTS_TXT_OUTFIT.." \""..outfitName.."\" "..WARDROBE_CONSTANTS_TXT_WILLBEWORNWHENMOUNTED);
	end
end


---------------------------------------------------------------------------------
-- See if we're mounted
---------------------------------------------------------------------------------
function Wardrobe.PlayerIsMounted()
	if (not IsMounted) then return end
	return UnitIsMounted("player");
end

function Wardrobe.CheckForMounted()
	--Sea.io.print("CheckForMounted");
	if (not IsMounted) then return end
	local mounted = Wardrobe.PlayerIsMounted();
	Wardrobe.EventTaskToggle(mounted, "MountState", "mount", "unmount");
end


---------------------------------------------------------------------------------
-- See if we're eating/drinking
---------------------------------------------------------------------------------
function Wardrobe.PlayerIsEatingOrDrinking()
	-- check our buffs for an eat or drink buff
	for i = 1, 16 do
		local texture = UnitBuff("player", i);
		if (texture) then
			if (string.find(texture,"INV_Misc_Fork") or string.find(texture,"INV_Drink")) then
				return 1;
			end
		end
	end
end

function Wardrobe.CheckForEatDrink()
	local chowing = Wardrobe.PlayerIsEatingOrDrinking();
	Wardrobe.EventTaskToggle(chowing, "ChowingState", "eating", "uneating");
end

---------------------------------------------------------------------------------
-- See if we switched into or out of the plaguelands
---------------------------------------------------------------------------------

function Wardrobe.PlayerIsInPlagueZone()
	local currZone = GetZoneText();
	Wardrobe.CurrentZone = currZone;
	for i = 1, table.getn(WARDROBE_CONSTANTS_PLAGUEZONES) do
		if (currZone == WARDROBE_CONSTANTS_PLAGUEZONES[i]) then
			return 1;
		end
	end
end

function Wardrobe.ChangedZone()
	if (Wardrobe.CurrentZone ~= GetZoneText()) then
		local inPlagueZone = Wardrobe.PlayerIsInPlagueZone();
		Wardrobe.EventTaskToggle(inPlagueZone, nil, "plague", "unplague");
	end
end

---------------------------------------------------------------------------------
-- See if we're swimming, or at least if the breath bar is up.
---------------------------------------------------------------------------------
function Wardrobe.PlayerIsSwimming()
	local breathBar;
	for i=1,3 do
		breathBar = getglobal("MirrorTimer"..i.."Text");
		if (breathBar:IsVisible()) and (breathBar:GetText() == BREATH_LABEL) then
			return 1;
		end
	end
end

function Wardrobe.CheckForSwimming()
	local swimming = Wardrobe.PlayerIsSwimming();
	Wardrobe.EventTaskToggle(swimming, nil, "swim", "unswim");
end

---------------------------------------------------------------------------------
-- Wear the outfit specially tagged as indicated
---------------------------------------------------------------------------------
function Wardrobe.WearSpecialOutfit(specialID, virtualOutfitName, wearIt)

	Wardrobe.CheckForOurWardrobeID();
		
	local outfitNumber = nil;
	for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
		if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Special == specialID) then
			outfitNumber = i;
			break;
		end
	end

	if (outfitNumber) then
		if (wearIt) then
			-- remember what we're wearing before we put on the special outfit
			Wardrobe.StoreVirtualOutfit(virtualOutfitName, Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNumber].OutfitName);
			-- wear our special outfit
			Wardrobe.WearOutfit(Wardrobe_Config[WD_realmID][WD_charID].Outfit[outfitNumber].OutfitName, true);
		else
			-- re-equip the virtual outfit
			Wardrobe.CheckForEquipVirtualOutfit(virtualOutfitName);
		end
	end
end

---------------------------------------------------------------------------------
-- Trigger special outfits or add task to task list based on event trigger
---------------------------------------------------------------------------------

function Wardrobe.EventTaskToggle(value, variableName, trueTaskID, falseTaskID)
	
	local taskID;
	-- toggle the state and schedule wearing our tasked outfit
	if (variableName) then
		--Sea.io.print("Value: ", value, " ", variableName, " ", Wardrobe[variableName]);
		if (value) and (not Wardrobe[variableName]) then
			taskID = trueTaskID;
		elseif (not value) and (Wardrobe[variableName]) then
			taskID = falseTaskID;
		end
	else
		if (value) then
			taskID = trueTaskID;
		else
			taskID = falseTaskID;
		end
	end
	
	if (taskID) then
		local taskInfo = Wardrobe.WaitingListVirtualNames[taskID];
		if (variableName) then
			Wardrobe[variableName] = taskInfo.toggle;
		end
		if (Wardrobe.IsPlayerInCombat()) then
			Wardrobe.AddToWaitingList(taskID);
		else	
			local eventID = taskInfo.id;
			Wardrobe.WearSpecialOutfit(eventID, Wardrobe.SpecialOutfitVirtualNames[eventID], taskInfo.toggle);
		end	
	end
   
end

---------------------------------------------------------------------------------
-- Waiting Task List Functions
---------------------------------------------------------------------------------

function Wardrobe.AddToWaitingList(theTask)
	--Sea.io.print("Adding "..theTask.." to waiting list!");
	table.insert(Wardrobe.WaitingList, theTask);
end


function Wardrobe.CheckWaitingList()
	--Sea.io.print("Checking Wardrobe.WaitingList: "..asText(Wardrobe.WaitingList));
	for i = 1, table.getn(Wardrobe.WaitingList) do
		local theTask = table.remove(Wardrobe.WaitingList, 1);
		--Sea.io.print("Popped "..theTask.." from waiting list!");
		local taskID;
		for taskName, taskInfo in Wardrobe.WaitingListVirtualNames do
			taskID = taskInfo.id;
			if (theTask == taskID) then
				Wardrobe.WearSpecialOutfit(taskID, Wardrobe.SpecialOutfitVirtualNames[taskID], taskInfo.toggle);
				break;
			end
		end
	end
end


---------------------------------------------------------------------------------
-- Store what we're currently wearing in a virtual outfit
---------------------------------------------------------------------------------
function Wardrobe.StoreVirtualOutfit(virtualOutfitName, currentOutfitName)

	local currentOutfitNum;
	if (type(currentOutfitName) == "number") then
		currentOutfitNum = currentOutfitName;
	else
		currentOutfitNum = Wardrobe.GetOutfitNum(currentOutfitName);
	end
	
	Wardrobe.ItemCheckState = { };
	for i = 1, Wardrobe.InventorySlotsSize do
		local val = Wardrobe_Config[WD_realmID][WD_charID].Outfit[currentOutfitNum].Item[i].IsSlotUsed;
		if (val ~= 1) then val = 0; end
		table.insert(Wardrobe.ItemCheckState, val);
	end	

	-- get a new outfit struct
	local newOutfitNum = Wardrobe.GetNextFreeOutfitSlot(true);

	-- this new outfit will remember what we're about to remove in order to wear our mounted outfit
	Wardrobe.StoreItemsInOutfit(virtualOutfitName, newOutfitNum);

	-- set this outfit to virtual so it'll be hidden and not show up as a normal outfit
	Wardrobe_Config[WD_realmID][WD_charID].Outfit[newOutfitNum].Virtual = true;
end


---------------------------------------------------------------------------------
-- If we have a virtual outfit, wear it and delete it
---------------------------------------------------------------------------------
function Wardrobe.CheckForEquipVirtualOutfit(virtualOutfitName)

	if (not virtualOutfitName) then virtualOutfitName = WARDROBE_CONSTANTS_TEMP_OUTFIT_NAME; end
	
	if (Wardrobe.FoundOutfitName(virtualOutfitName)) then
		Wardrobe.WearOutfit(virtualOutfitName, true);
		Wardrobe.EraseOutfit(virtualOutfitName, true);
	end
end


---------------------------------------------------------------------------------
-- Update whether we have all the items for our outfits in our bags
---------------------------------------------------------------------------------
function Wardrobe.UpdateOutfitAvailability()

	if (Wardrobe_Config.Enabled and not Wardrobe.InCombat) then
	
		-- if we haven't already looked up our character's number
		Wardrobe.CheckForOurWardrobeID();

		Wardrobe.Debug("Wardrobe Availability:");
		
		local masterItemList = Wardrobe.BuildItemList();
	
		-- for each outfit
		for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do

			-- if it has a name
			if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName ~= "") then

				local foundAllItems = true;

				-- for each item in the outfit
				for j = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Item) do

					-- if this slot is used in this outfit
					if (Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Item[j].IsSlotUsed == 1) then

						local outfitItem = Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Item[j];
						
						if (outfitItem.ItemID) and (outfitItem.Suffix) and (outfitItem.PermEnchant) then
							local foundTheItem = false;
							for k = 1, table.getn(masterItemList) do
								if (outfitItem.ItemID == masterItemList[k].ItemID) and (outfitItem.Suffix == masterItemList[k].Suffix) and (outfitItem.PermEnchant == masterItemList[k].PermEnchant) then
									foundTheItem = true;
									break;
								end
							end
							if (not foundTheItem) then 
								foundAllItems = false;
								break;
							end
						
						elseif (outfitItem.Name) and (outfitItem.Name ~= "") then
							local foundTheItem = false;
							for k = 1, table.getn(masterItemList) do
								if (outfitItemName == masterItemList[k].Name) then
									foundTheItem = true;
									break;
								end
							end
							if (not foundTheItem) then 
								foundAllItems = false;
								break;
							end
						end
					end	
				end

				-- if we found all items in our inventory
				Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Available = foundAllItems;
				Wardrobe.Debug("   Outfit \""..Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName.."\" -- found all items = "..tostring(foundAllItems));
			end
		end
	end
end


---------------------------------------------------------------------------------
-- Determine which outfit we're currently wearing
---------------------------------------------------------------------------------
function Wardrobe.DetermineActiveOutfit()

	Wardrobe.Debug("Wardrobe.DetermineActiveOutfit: Updating Active Outfit");
	local ActiveOutfitList = { };
	local foundOutfit = false;
	
	-- build a reference table of the currently equipped items
	Wardrobe.CurrentlyEquippedItemList = { };
	for j = 1, Wardrobe.InventorySlotsSize do
		local itemID, permEnchant, tempEnchant, suffix, itemName = Wardrobe.GetItemInfoAtInventorySlotNumber(j);
		table.insert(Wardrobe.CurrentlyEquippedItemList, {Name = itemName, ItemID = itemID, PermEnchant = permEnchant, TempEnchant = tempEnchant, Suffix = suffix});
	end	

	-- for each outfit
	for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
	
		Wardrobe.Debug("  Working on outfit "..i..": "..Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].OutfitName);
		
		foundOutfit = true;
		
		-- for each slot on our character (hands, neck, head, feet, etc)
		local item;
		for j = 1, Wardrobe.InventorySlotsSize do
			item = Wardrobe_Config[WD_realmID][WD_charID].Outfit[i].Item[j];
			-- if this slot is used in this outfit
			if (item.IsSlotUsed == 1) then

				-- if this item is different from what we're already wearing
				local thisItem = Wardrobe.CurrentlyEquippedItemList[j];
				Wardrobe.Debug("	Working on slot -> "..Wardrobe.InventorySlots[j]);
				-- item in inv slot
				if (thisItem.Name) then
					Wardrobe.Debug("	   Comparing ["..tostring(item.Name).."] with ["..tostring(thisItem.Name).."]");
					if (item.ItemID) and (item.Suffix) and (item.PermEnchant) then
						if (item.ItemID ~= thisItem.ItemID) or (item.Suffix ~= thisItem.Suffix) or (item.PermEnchant ~= thisItem.PermEnchant) then
							foundOutfit = false;
							break;
						end
					elseif (item.Name) and (item.Name ~= "") then
						if (item.Name ~= thisItem.Name) then
							foundOutfit = false;
							break;
						end
					else
						-- Forced empty slot
						foundOutfit = false;
						break;
					end
				
				-- no item in inv slot
				elseif (item.Name) then
					foundOutfit = false;
					break;
				end
			end
		end
		
		if (foundOutfit) then
			table.insert(ActiveOutfitList, i);
		end
	 end
	 
	 return ActiveOutfitList;	 
end

--============================================================================================--
--============================================================================================--
--																							--
--							  UTILITY FUNCTIONS											 --
--																							--
--============================================================================================--
--============================================================================================--


-----------------------------------------------------------------------------------
-- Our own print function
-----------------------------------------------------------------------------------
function Wardrobe.Print(theMsg, r, g, b)
	
	-- 0.50, 0.50, 1.00
	if (r == nil) then r = 0.50; end
	if (g == nil) then g = 0.50; end
	if (b == nil) then b = 1.00; end

	if (type(theMsg) == "table") then
		Print(asText(theMsg), r, g, b);
	else
		Print(theMsg, r, g, b);
	end
end


-----------------------------------------------------------------------------------
-- Toggle the plugin on and off
-----------------------------------------------------------------------------------
function Wardrobe.Toggle(toggle)
	if (toggle == 1) then
		if (not Khaos) then
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_ENABLED);
		end
		Wardrobe_Config.Enabled = true;
		Wardrobe.IconFrame:Show();
	else
		if (not Khaos) then
			Wardrobe.Print(WARDROBE_CONSTANTS_TXT_DISABLED);
		end
		Wardrobe_Config.Enabled = false;
		Wardrobe.IconFrame:Hide();
	end
end


-----------------------------------------------------------------------------------
-- Nifty little function to view any lua object as text
-----------------------------------------------------------------------------------
function asText(obj)

	visitRef = {}
	visitRef.n = 0

	asTxRecur = function(obj, asIndex)
		if type(obj) == "table" then
			if visitRef[obj] then
				return "@"..visitRef[obj]
			end
			visitRef.n = visitRef.n +1
			visitRef[obj] = visitRef.n

			local begBrac, endBrac
			if asIndex then
				begBrac, endBrac = "[{", "}]"
			else
				begBrac, endBrac = "{", "}"
			end
			local t = begBrac
			local k, v = nil, nil
			repeat
				k, v = next(obj, k)
				if k ~= nil then
					if t > begBrac then
						t = t..", "
					end
					t = t..asTxRecur(k, 1).."="..asTxRecur(v)
				end
			until k == nil
			return t..endBrac
		else
			if asIndex then
				-- we're on the left side of an "="
				if type(obj) == "string" then
					return obj
				else
					return "["..obj.."]"
				end
			else
				-- we're on the right side of an "="
				if type(obj) == "string" then
					return '"'..obj..'"'
				else
					return tostring(obj)
				end
			end
		end
	end -- asTxRecur

	return asTxRecur(obj)
end -- asText


---------------------------------------------------------------------------------
-- Display the help text
---------------------------------------------------------------------------------
function Wardrobe.ShowHelp()
	Wardrobe.Print("Wardrobe, an AddOn by AnduinLothar, Miravlix  and Cragganmore, Version "..WARDROBE_CONSTANTS_VERSION);
	Wardrobe.Print("Wardrobe allows you to define and switch among up to 20 different outfits.");
	Wardrobe.Print("The main interface can be accessed from the Wardrobe icon, which defaults");
	Wardrobe.Print("to just under your minimap/radar.  You may also use the following commands:");
	Wardrobe.Print("Usage: /wardrobe <wear/list/reset/lock/unlock/click/mouseover>");
	Wardrobe.Print("   wear [outfit name] - Wear the specified outfit.");
	Wardrobe.Print("   list - List your outfits.");
	Wardrobe.Print("   reset - Delete all outfits in your wardrobe.");
	Wardrobe.Print("   lock/unlock - Lock or unlock moving the wardrobe icon interface.");
	Wardrobe.Print("   click/mouseover - Show the wardrobe menu on mouseover or only on click.");
	Wardrobe.Print("In the UI, outfit names are colored as follows:");
	Wardrobe.Print("   Bright Colored: Your currently equipped outfit.");
	Wardrobe.Print("   Drab Colored: An outfit where one or more items aren't currently equipped.");
	Wardrobe.Print("   Grey: An outfit where one or more items aren't in your inventory.");
	Wardrobe.Print("   Greyed outfits may still be equipped.  The missing items just won't be worn.");
end



--============================================================================================--
--============================================================================================--
--																							--
--							  DEBUG FUNCTIONS											   --
--																							--
--============================================================================================--
--============================================================================================--


-----------------------------------------------------------------------------------
-- Print out a debug statement if the WARDROBE_CONSTANTS_DEBUG flag is set
-----------------------------------------------------------------------------------
function Wardrobe.Debug(theMsg)
	if (WARDROBE_CONSTANTS_DEBUG) then
		ChatFrame1:AddMessage(theMsg, 1.0, 1.0, 0.7);
	end
end


---------------------------------------------------------------------------------
-- Toggle debug output
---------------------------------------------------------------------------------
function Wardrobe.ToggleDebug()
	WARDROBE_CONSTANTS_DEBUG = not WARDROBE_CONSTANTS_DEBUG;
	if (WARDROBE_CONSTANTS_DEBUG) then
		Print("Wardrobe: Debug ON",1.0,1.0,0.5);
	else
		Print("Wardrobe: Debug OFF",1.0,1.0,0.5);
	end	
end


---------------------------------------------------------------------------------
-- Debug routine to print the current state of the plugin
---------------------------------------------------------------------------------
function Wardrobe.DumpDebugReport()
	
	Wardrobe.CheckForOurWardrobeID();
	
	Wardrobe.Debug("Wardrobe.DumpDebugReport: Character's wardrobe database");
	local items;
	local WardrobeDatabase = Wardrobe_Config[WD_realmID][WD_charID];
	for outfitNum = 1, table.getn(WardrobeDatabase.Outfit) do
		Wardrobe.Debug("Outfit: "..tostring(WardrobeDatabase.Outfit[outfitNum].OutfitName));
		items = WardrobeDatabase.Outfit[outfitNum].Item;
		for i = 1, Wardrobe.InventorySlotsSize do
			Wardrobe.Debug(Wardrobe.InventorySlots[i].." = "..tostring(items[i].Name));
		end
	end
end



---------------------------------------------------------------------------------
-- Print a debug report
---------------------------------------------------------------------------------
function Wardrobe.DumpDebugStruct()
	for i = 1, table.getn(Wardrobe_Config[WD_realmID][WD_charID].Outfit) do
		Print("Outfit #"..i..":");
		Print(asText(Wardrobe_Config[WD_realmID][WD_charID].Outfit[i]));
		Print("--------------------");
	end
end


